import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "react/jsx-runtime";
import classNames from "classnames";
import { useState } from "react";
import Spinner from "./components/Spinner";
export default function DataTable({ columns, data, loading, usePagination, totalPages, onPageChange, dark = false, containerClassName, }) {
    const [currentPage, setCurrentPage] = useState(1);
    const handlePageChange = (page) => {
        setCurrentPage(page);
        if (onPageChange) {
            onPageChange(page);
        }
    };
    return (_jsx("div", { className: classNames(containerClassName, "mt-8 p-4 rounded-lg shadow-md", {
            "bg-gray-800": dark,
            "bg-white": !dark,
        }), children: _jsx("div", { className: "w-full overflow-x-auto", children: loading ? (_jsx(Spinner, {})) : (_jsxs(_Fragment, { children: [_jsxs("table", { className: classNames("w-full divide-y", {
                            "divide-gray-700": dark,
                            "divide-gray-200": !dark,
                        }), children: [_jsx("thead", { className: classNames("rounded-lg", {
                                    "bg-gray-700": dark,
                                    "bg-gray-200": !dark,
                                }), children: _jsx("tr", { children: columns.map((column) => (_jsx("th", { className: classNames("px-6 py-3 text-left text-xs font-medium uppercase tracking-wider", {
                                            "text-gray-300": dark,
                                            "text-gray-700": !dark,
                                        }), children: column.header }, column.accessor))) }) }), _jsx("tbody", { className: classNames({
                                    "bg-gray-800 divide-y divide-gray-700": dark,
                                    "bg-white divide-y divide-gray-200": !dark,
                                }), children: data.length === 0 ? (_jsx("tr", { children: _jsx("td", { colSpan: columns.length, className: classNames("px-6 py-4 whitespace-nowrap text-center text-sm", {
                                            "text-gray-400": dark,
                                            "text-gray-500": !dark,
                                        }), children: "No data found" }) })) : (data.map((item, index) => (_jsx("tr", { children: columns.map((column) => (_jsx("td", { className: classNames("px-6 py-4 whitespace-nowrap text-sm", {
                                            "text-gray-300": dark,
                                            "text-gray-700": !dark,
                                        }), children: column.renderRow
                                            ? column.renderRow(item)
                                            : String(item[column.accessor]) }, column.accessor))) }, index)))) })] }), usePagination && (_jsxs("div", { className: "w-full flex justify-between items-center mt-4", children: [_jsx("button", { onClick: () => handlePageChange(currentPage - 1), disabled: currentPage === 1, className: classNames("px-4 py-2 rounded disabled:opacity-50", {
                                    "bg-gray-600 text-white": dark,
                                    "bg-gray-200 text-gray-700": !dark,
                                }), children: "Previous" }), _jsxs("span", { className: classNames({
                                    "text-white": dark,
                                    "text-gray-700": !dark,
                                }), children: ["Page ", currentPage, " of ", totalPages] }), _jsx("button", { onClick: () => handlePageChange(currentPage + 1), disabled: currentPage === totalPages, className: classNames("px-4 py-2 rounded disabled:opacity-50", {
                                    "bg-gray-600 text-white": dark,
                                    "bg-gray-200 text-gray-700": !dark,
                                }), children: "Next" })] }))] })) }) }));
}
